-- ===================================================================

local frommod
local basepart
local fromnode
local neednode

-- ===================================================================

local colors = { "dark_orange", "medium_red", "dark_red" }

for _, color in ipairs (colors) do

    frommod  = "coloredwood"
    basepart = "wood_" .. color
    fromnode = frommod .. ":"       .. basepart
    neednode = frommod .. ":slope_" .. basepart
    --
    if  coderblocks.has_moreblocks     and
        ocutil.node_missing (neednode) and
        ocutil.node_exists  (fromnode) then
        local png = frommod .. "_" .. basepart .. ".png"

        stairsplus:register_all (frommod,
            basepart ,
            fromnode ,
            {
                groups = {
                    snappy=1, choppy=2,
                    oddly_breakable_by_hand=2,
                    flammable=2,
                    not_in_creative_inventory=1
                } ,

                tiles       = { png } ,
                description = color .. " wood planks" ,
                drop        = fromnode ,
            })
    end
end

-- ===================================================================
-- End of file.
