-- ===================================================================

local cvt = default.convert_node
local neednode

-- ===================================================================

cvt ("decoblocks:anvil"                 ,
         "castle:anvil"                 )
cvt ("decoblocks:plank_walkway"         ,
     "basic_materials:concrete_block"   )

-- ===================================================================

neednode = "decoblocks:bamboo_fence"
--
if  minetest.registered_nodes [neednode] == nil then
    minetest.register_node (":" .. neednode, {
        description = "Bamboo Fence" ,
        tiles       = {
            "decoblocks_bamboo_fence_top.png" ,
            "decoblocks_bamboo_fence_top.png" ,
            "decoblocks_bamboo_fence.png"     ,
        } ,

        inventory_image =
"default_fence_overlay.png^decoblocks_bamboo.png^default_fence_overlay.png^[makealpha:255,126,126" ,

        wield_image = "default_fence_overlay.png^decoblocks_bamboo.png^default_fence_overlay.png^[makealpha:255,126,126" ,
        drawtype   = "nodebox" ,
        paramtype  = "light"   ,

        connects_to = {
            "group:fence", "group:wood", "group:choppy", "group:stone"
        } ,

        node_box = {
            type = "connected" ,
            fixed = {
                {-0.125, -0.5, -0.125, 0.125, 0.5, 0.125} , -- NodeBox1
            } ,
            connect_back = {
                {-0.125, -0.5, -0.125, 0.125, 0.5, 0.125} , -- NodeBox1
                {-0.0625, 0.25, -0.0625, 0.0625, 0.375, 0.5} , -- NodeBox2
                {-0.0625, -0.0625, -0.0625, 0.0625, 0.0625, 0.5} , -- NodeBox3
                {-0.0625, -0.375, -0.0625, 0.0625, -0.25, 0.5} , -- NodeBox4
            } ,
            connect_front = {
                {-0.125, -0.5, -0.125, 0.125, 0.5, 0.125} , -- NodeBox1
                {-0.0625, 0.25, -0.5, 0.0625, 0.375, 0.0625} , -- NodeBox2
                {-0.0625, -0.0625, -0.5, 0.0625, 0.0625, 0.0625} , -- NodeBox3
                {-0.0625, -0.375, -0.5, 0.0625, -0.25, 0.0625} , -- NodeBox4
            } ,
            connect_left = {
                {-0.125, -0.5, -0.125, 0.125, 0.5, 0.125} , -- NodeBox1
                {-0.5, 0.25, -0.0625, 0.0625, 0.375, 0.0625} , -- NodeBox2
                {-0.5, -0.0625, -0.0625, 0.0625, 0.0625, 0.0625} , -- NodeBox3
                {-0.5, -0.375, -0.0625, 0.0625, -0.25, 0.0625} , -- NodeBox4
            } ,
            connect_right = {
                {-0.125, -0.5, -0.125, 0.125, 0.5, 0.125} , -- NodeBox1
                {0, 0.25, -0.0625, 0.5, 0.375, 0.0625} , -- NodeBox2
                {0, -0.0625, -0.0625, 0.5, 0.0625, 0.0625} , -- NodeBox3
                {0, -0.375, -0.0625, 0.5, -0.25, 0.0625} , -- NodeBox4
            }
        } ,

        groups = {
            choppy=1, oddly_breakable_by_hand=1, fence=1
        } ,

        sounds = default.sound_wood() ,
    })
end

-- ===================================================================

neednode = "decoblocks:bamboo_block"
--
if  minetest.registered_nodes [neednode] == nil then
    minetest.register_node (":" .. neednode, {
        description = "Bamboo Block" ,

        tiles       = {
            "decoblocks_bamboo_top.png" ,
            "decoblocks_bamboo_top.png" ,
            "decoblocks_bamboo.png"     ,
        } ,

        groups = { choppy = 1,
            oddly_breakable_by_hand = 2, wood=1
        } ,

        sounds   = default.sound_wood() ,
        on_place = minetest.rotate_node ,
    })
end

-- ===================================================================
-- End of file.
