-- ===================================================================

local cvt       = default.convert_node
local reg_alias = ocutil.safe_register_alias
local reg_item  = ocutil.safe_register_item
local reg_node  = ocutil.safe_register_node

local needitem
local neednode

-- ===================================================================

if false then
cvt ("castle_tapestries:tapestry_very_long" ,
     "air"                                  )
end

cvt ("cblocks:wood_yellow2"                 ,
     "cblocks:wood_yellow"                  )

cvt ("clothing:loom"                        ,
     "air"                                  )

cvt ("clothing_stand:clothing_stand"        ,
     "air"                                  )

cvt ("default:chest_locked_open"            ,
     "default:chest_locked"                 )

cvt ("farming:sunflower_8"                  ,
     "nftools:sunflower"                    )

cvt ("moreblocks:slab_ice"                  ,
         "stairs:slab_ice"                  )

cvt ("moreblocks:trap_desert_stone"         ,
     "moreblocks:trap_sandstone"            )

cvt ("travelnet:elevator_door_tin_open"     ,
     "travelnet:elevator_door_glass_open"   )

cvt ("wardrobe:wardrobe"                    ,
     "air"                                  )

cvt ("woodsoils:dirt_with_leaves_1"         ,
     "default:dirt_with_grass"              )

-- ===================================================================

cvt (  "maple:fence_maple_wood"             ,
     "default:fence_maple_wood"             )

cvt (  "maple:maple_leaves"                 ,
     "default:maple_leaves"                 )

cvt (  "maple:maple_sapling"                ,
     "default:maple_sapling"                )

cvt (  "maple:maple_wood"                   ,
     "default:maple_wood"                   )

cvt (  "maple:maple_tree"                   ,
     "default:maple_trunk"                  )

-- ===================================================================

cvt ("christmas_decor:christmas_shrubbery_large" ,
                   "gloopblocks:shrubbery_large" )

-- ===================================================================

needitem = "mobs:feather"
--
if minetest.registered_items [needitem] == nil then
    reg_item (needitem, {
        description = "Feather" ,
        inventory_image = "creatures_feather.png" ,
    })
end

-- ===================================================================

nodepart = "glowstone"
fromnode = "coderblocks:" .. nodepart
--
if ocutil.node_exists (fromnode) then
    stairs.register_all (nodepart, fromnode,
        { cracky=2                              } ,
        { "glowstone_glowstone.png"             } ,
        "Glowstone"                               ,
        stairs.snd_stone)
end

-- ===================================================================

nodepart = "lava_gel"
fromnode = "default:" .. nodepart
--
if ocutil.node_exists (fromnode) then
    stairs.register_all (nodepart, fromnode,
        { cracky=2                            } ,
        { "default_lava.png"                  } ,
        "Lava"                                  ,
        stairs.snd_stone)
end

reg_alias ("stairs:stair_lava"       , "stairs:stair_lava_gel"      )
reg_alias ("stairs:stair_outer_lava" , "stairs:stair_outer_lava_gel")

-- ===================================================================

neednode = "birthstones:opalblock"
--
if ocutil.thing_missing (neednode) then
reg_node (neednode, {
    description = "Opal Block",
    tiles = { "birthstones_opal_block.png" } ,
    is_ground_content = true,
    groups = { cracky=1, level=3 } ,
    sounds = default.sound_stone(),
})
end

-- ===================================================================

neednode = "caverealms:salt_crystal"
--
if ocutil.thing_missing (neednode) then
reg_node (neednode, {
    description = "Salt Crystal" ,
    tiles = { "caverealms_salt_crystal.png" } ,
    is_ground_content = true,
    groups = {cracky=3},
    sounds = default.sound_glass() ,
    light_source = 11,
    paramtype = "light",
    use_texture_alpha = true,
    drawtype = "glasslike",
    sunlight_propagates = true,
})
end

-- ===================================================================
-- A 2D but HQ planet.

if type (placecraft) == "table" then
placecraft.register_item ("toys:planet", {
    description = "Planet"          ,
    drawtype    = "sprite"          ,
    image       = "toys_planet.png" ,
    vsize       = 1.00              ,
})
end

-- ===================================================================
-- Some 2D but HQ gems.

local ngems = {
    "amethyst" , "aquamarine" , "diamond"  ,
    "emerald"  , "ruby"       , "sapphire" ,
}

if type (placecraft) == "table" then
    for _, basename in ipairs (ngems) do
        local node = "ngems:" .. basename

        placecraft.register_item (node, {
            description = ocutil.first_to_upper (basename) ,
            drawtype    = "sprite"                         ,
            image       = "ngems_" .. basename .. ".png"   ,
            vsize       = 0.50                             ,
        })
    end
end

-- ===================================================================

if  ocutil.bool_default ("default_skylands") then
    minetest.override_item ("default:dirt" , {
        tiles = { "skylands_rich_dirt.png" } ,
    })

    minetest.override_item ("default:dirt_with_grass", {
        tiles       = {
            "skylands_heavengrass2.png" ,
            "skylands_rich_dirt.png" ,
            "skylands_rich_dirt.png^skylands_heavengrass_side2.png"
        } ,
    })
end

-- ===================================================================

nodepart = "diamondblock"
fromnode = "default:" .. nodepart
neednode = fromnode   .. "_panel"
--
if  coderblocks.has_moreblocks     and
    ocutil.node_missing (neednode) and
    ocutil.node_exists  (fromnode) then

    register_stair_slab_panel_micro ("default",
        "diamondblock" , "default:diamondblock" ,
        { cracky=3, oddly_breakable_by_hand=2 } ,
        { "default_diamondblock.png"          } ,
        "Diamond Block" ,
        "diamondblock"  , 0)

    reg_alias (neednode, "default:panel_diamondblock")
end

-- ===================================================================

neednode = "icetools:ice_crystal_block"

if  ocutil.node_missing (neednode) then
    img = "icetools_ice_crystal_block.png"

    reg_node (neednode, {
        description = 'Refined Ice Crystal Block' ,
        paramtype2  = 'facedir' ,

        tiles = {
img,
img .. "^[transformR270" ,
img .. "^[transformR90"  ,
img,
img .. "^[transformR270" ,
img .. "^[transformR180" ,
        } ,

        light_source = default.LIGHT_MAX ,
        groups = { cracky=1, level=3 } ,
        sounds = default.node_sound_stone_defaults() ,
    })
end

-- ===================================================================

reg_node ("rangedweapons:antigun_block", {
    description = "antigun block" ,
    tiles       = {"rangedweapons_antigun_block.png" } ,
    groups      = { choppy = 3, oddly_breakable_by_hand=3 } ,
    sounds      = default.node_sound_wood_defaults(),
})

cvt ("moreblocks:clean_super_glow_glass"       ,
        "default:clean_super_glow_glass"       )

cvt ("moreblocks:stair_clean_super_glow_glass" ,
        "default:stair_clean_super_glow_glass" )

-- ===================================================================

reg_node ("osiris:rainbow", {
    description = "Osiris Rainbow" ,
    tiles       = {
        "osrainbow2.png", -- top
        "osrainbow2.png", -- bottom
        "osrainbow2.png", -- right
        "osrainbow2.png", -- left
        "osrainbow2.png", -- back
        "osrainbow2.png"  -- front
    } ,

    light_source   = 10                          ,
    paramtype      = "light"                     ,

    groups = { oddly_breakable_by_hand = 2 }     ,
    sounds = default.node_sound_stone_defaults() ,
})
                    
-- ===================================================================

minetest.register_craftitem ("coderblocks:comb", {
    description = "Final MT Comb" ,
    inventory_image = "occomb.png",
    stack_max = 64,
    groups = { craftitem = 1 },
})

minetest.register_craftitem ("coderblocks:shampoo", {
    description = "Final MT shampoo" ,
    inventory_image = "ocshampoo.png",
    stack_max = 64,
    groups = { craftitem = 1 },
})

minetest.register_craftitem ("coderblocks:soap", {
    description = "Final MT bar soap" ,
    inventory_image = "ocsoap.png" ,
    stack_max = 64 ,
    groups = { craftitem = 1 } ,
})

minetest.register_craftitem ("coderblocks:gloreo", {
    description = "Gloreo Cookie" ,
    inventory_image = "gloreo.png" ,
    on_use = minetest.item_eat (4) ,
})

minetest.register_craftitem ("coderblocks:pacifier", {
    description = "Pacifier" ,
    inventory_image = "coderblocks_pacifier.png" ,
})

minetest.register_craftitem ("coderblocks:babybottle", {
    description = "Baby Bottle" ,
    inventory_image = "coderblocks_babybottle.png" ,
})

minetest.register_craftitem ("coderblocks:cattreats", {
    description = "Cat Treats" ,
    inventory_image = "coderblocks_cattreats.png" ,
})

minetest.register_craftitem ("coderblocks:cellphone", {
    description = "Cellphone" ,
    inventory_image = "coderblocks_cellphone.png" ,
})

minetest.register_craftitem ("coderblocks:corndog", {
    description = ("Corn Dog"),
    inventory_image = "occorndog.png" ,
    on_use = minetest.item_eat(8),  
})

-- ===================================================================

reg_node ("coderblocks:espalette", {
    description = "Eyeshadow Palette" ,

    tiles = {
        "espalette_top.jpg"  , -- Top
        "espalette_top.jpg"  , -- Bottom
        "espalette_side.jpg" , -- Right
        "espalette_side.jpg" , -- Left
        "espalette_side.jpg" , -- Back
        "espalette_side.jpg" , -- Front
    },

    light_source    = 10                   ,
    paramtype       = "light"              ,
    inventory_image = "espalette_side.jpg" ,

    groups = { oddly_breakable_by_hand = 2 }     ,
    sounds = default.node_sound_stone_defaults() ,
})

-- ===================================================================

cvt (   "ocblocks:lmb_cheese"                  ,
     "coderblocks:lmb_cheese"                  )

cvt ("technic:copper_locked_chest"             ,
      "default:chest_locked"                   )

cvt ("spawners_mobs:balrog"                    ,
     "default:coalblock"                       )

cvt ("spawners_mobs:deco_stone_eye"            ,
     "default:stone_with_mese"                 )

cvt ("spawners_mobs:deco_stone_sun"            ,
     "default:stone"                           )

cvt ("spawners_mobs:mobs_oerkki_spawner_rusty" ,
     "default:brick"                           )

cvt ("obsidianmese:chest"                      ,
     "default:chest"                           )

-- ===================================================================
-- End of file.
