-- ===================================================================

-- This file  provides a  replacement for the original  Home Decor re-
-- frigerator.

-- A related  alias in the  "ocfixups" mod is used to  replace missing
-- Home Decor "refrigerator" nodes.

-- ===================================================================

minetest.register_node ("coderblocks:refrigerator", {
    drawtype = "nodebox",
    description = "Refrigerator" ,
    tiles = {
        "coderblocks_refrigerator_top.png",
        "coderblocks_refrigerator_bottom.png",
        "coderblocks_refrigerator_right.png",
        "coderblocks_refrigerator_left.png",
        "coderblocks_refrigerator_back.png",
        "coderblocks_refrigerator_front.png"
    },
    inventory_image = "coderblocks_refrigerator_inv.png",
    sunlight_propagates = false,
    paramtype = "light",
    paramtype2 = "facedir",
    walkable = true,
    groups = { snappy = 3 },

    selection_box = {
        type = "fixed",
        fixed = { -0.5, -0.5, -0.5, 0.5, 1.5, 0.5 }
    },
    node_box = {
        type = "fixed",
        fixed = { -0.5, -0.5, -0.5, 0.5, 1.5, 0.5 }
    },

    sounds = default.sound_wood(),
    on_construct = function(pos)
        local meta = minetest.get_meta(pos)
        meta:set_string("formspec",
                "size[10,10]"..
                "list[current_name;main;0,0;10,5;]"..
                "list[current_player;main;1,6;8,4;]")
        meta:set_string("infotext", "Refrigerator")
        local inv = meta:get_inventory()
        inv:set_size("main",50)
    end,

    on_place = function(itemstack, placer, pointed_thing)
        local pos = pointed_thing.above
        if minetest.get_node({x=pos.x, y=pos.y+1, z=pos.z}).name ~= "air" then
            minetest.chat_send_player( placer:get_player_name(),
                "Not enough vertical space to place a refrigerator!")
            return
        end
        return minetest.item_place(itemstack, placer, pointed_thing)
    end,

    can_dig = function(pos,player)
        local meta = minetest.get_meta(pos);
        local inv = meta:get_inventory()
        return inv:is_empty("main")
    end,
})
