-- File:     codersea/seacobble.lua
-- Purpose:  CoderSea sea-cobble support
-- Credits:  See "codersea.md"
-- Licenses: See "LICENSE"

-- ===================================================================

local function register_seacobble_craft (output, recipe)
    minetest.register_craft ({
        type   = "shapeless" ,
        output = output      ,
        recipe = recipe      ,
    })
end

-- ===================================================================

local function register_seacobble    (suffix)
    local basename =   "seacobble" .. suffix
    local esuffix  = suffix:gsub ("_", " ")
    local nodename = "codersea:" .. basename
    local img      = "codersea_" .. basename .. ".png"

    minetest.register_node (nodename, {
        description       = "Sea-cobble" .. esuffix ,
        groups            = { cracky=3, stone=2 }   ,
        is_ground_content = true                    ,
        sounds            = sounds_stone            ,
        tiles             = { img }                 ,
    })

    if not codersea_disable_stairs then
        stairs.register_stair_and_slab (basename, nodename,
            { cracky=3, stone=2 }         ,
            { img }                       ,
            "Sea-cobble stair" .. esuffix ,
            "Sea-cobble slab"  .. esuffix ,
            sounds_stone)
    end

    if suffix:len() > 0 then
        local dye = ("dye" .. suffix):gsub ("_", ":")
        register_seacobble_craft (nodename ,
            { "codersea:seacobble", dye })
        register_seacobble_craft (nodename ,
            { "codersea:crushedwhite", "default:cobble" , dye })
    else
        register_seacobble_craft (nodename ,
            { "codersea:crushedwhite", "default:cobble" })
    end
end

-- ===================================================================

for  _,color in pairs (seastone_colors) do
    if color:len() > 0 then color = "_" .. color end
    register_seacobble (color)
end
