-- ===================================================================
-- conf-file setting(s).

local enable_wonder = minetest.setting_getbool ("enable_wonder")

-- ===================================================================
-- Determine stuff to give.

local default_stuff = "default:pick_steel"
local obj

if enable_wonder then
    default_stuff = default_stuff ..
        ",default:pick_steel,default:torch 50,default:bread 12"
else
    default_stuff = default_stuff ..
        ",default:axe_steel,default:shovel_steel,default:torch 99" ..
        ",default:cobble 99"
end

obj = "default:ncmask_off"
if ocutil.thing_exists (obj) then
    default_stuff = default_stuff .. "," .. obj
end

obj = "default:spacesuit_off"
if ocutil.thing_exists (obj) then
    default_stuff = default_stuff .. "," .. obj
end

local stuff_string = minetest.setting_get ("initial_stuff") or
    default_stuff

-- ===================================================================

give_initial_stuff = {
    items = {}
}

function give_initial_stuff.give(player)
    minetest.log("action",
            "Giving initial stuff to player " .. player:get_player_name())
    local inv = player:get_inventory()
    for _, stack in ipairs(give_initial_stuff.items) do
        inv:add_item("main", stack)
    end
end

function give_initial_stuff.add(stack)
    give_initial_stuff.items[#give_initial_stuff.items + 1] = ItemStack(stack)
end

function give_initial_stuff.clear()
    give_initial_stuff.items = {}
end

function give_initial_stuff.add_from_csv(str)
    local items = str:split(",")
    for _, itemname in ipairs(items) do
        give_initial_stuff.add(itemname)
    end
end

function give_initial_stuff.set_list(list)
    give_initial_stuff.items = list
end

function give_initial_stuff.get_list()
    return give_initial_stuff.items
end

give_initial_stuff.add_from_csv(stuff_string)
if minetest.setting_getbool("give_initial_stuff") then
    minetest.register_on_newplayer(give_initial_stuff.give)
end
