-- ===================================================================
-- "ufoods" common header.

local S
if minetest.get_modpath ("intllib") then
    S = intllib.Getter()
else
    S = function (s) return s end
end

local item_eat     = unified_foods.item_eat
local keep_vessels = unified_foods.keep_vessels
local mra          = minetest.registered_aliases
local mri          = minetest.registered_items

local reg_alias    = ocutil.safe_register_alias
local reg_craft    = minetest.register_craft
local reg_food     = unified_foods.register_food
local reg_item     = ocutil.safe_register_item
local reg_juice    = unified_foods.register_juice

local needitem

-- ===================================================================

local obj, obj1, obj2

-- ===================================================================

unified_foods.reg_moono = function (basename, args)

    if     type (args) == "string" then
        args = { description = args }
    elseif type (args) ~= "table"  then
        ocutil.panic ("reg_moono: Invalid arguments")
    end

    args.satiate    = 2
    args.heal       = 1

    return unified_foods.register_food (basename, args)
end

local reg_moono = unified_foods.reg_moono

-- ===================================================================
-- Moono Butterscotch Dillybar.

needitem = reg_moono ("dillybar", "Moono Butterscotch Dillybar")

reg_craft ({
    output = needitem .. " 4" ,
    recipe = {
        { ""           , "wool:blue" , "wool:red"  } ,
        { "wool:green" , ""          , "wool:blue" } ,
        { ""           , "wool:blue" , ""          } ,
    }
})

-- ===================================================================
-- Moono Butterscotch Sundae.

needitem = reg_moono ("sundae", "Moono Butterscotch Sundae")

reg_craft ({
    output = needitem .. " 4",
    recipe = {
        { ""           , "wool:blue" , "wool:red"  } ,
        { "wool:green" , "wool:red"  , "wool:blue" } ,
        { ""           , "wool:blue" , ""          } ,
    }
})

-- ===================================================================
-- Moono Heart on a Stick.

needitem = reg_moono ("heart", "Moono Heart on a Stick")

reg_craft ({
    output = needitem .. " 4" ,
    recipe = {
        { ""           , "wool:white" , "wool:red"  } ,
        { "wool:green" , "wool:red"   , "wool:blue" } ,
        { ""           , "wool:blue"  , ""          } ,
    }
})

-- ===================================================================
-- Moono Strawberry Bar.

needitem = reg_moono ("strawberry_bar", "Moono Strawberry Bar")

reg_craft ({
    output = needitem .. " 4",
    recipe = {
        { ""           , "wool:white" , "wool:red"  } ,
        { "wool:green" , "wool:red"   , "wool:blue" } ,
        { ""           , "wool:blue"  , ""          } ,
    }
})

-- ===================================================================
-- Moono Strawberry Icecream.

needitem = reg_moono ("strawberry_icecream",
    "Moono Strawberry Icecream")

reg_craft ({
    output = needitem .. " 4" ,
    recipe = {
        { ""           , "wool:white" , "wool:red"  } ,
        { "wool:green" , "wool:red"   , "wool:blue" } ,
        { ""           , "wool:white" , ""          } ,
    }
})

-- ===================================================================
-- Moono Strawberry Star.

reg_moono ("strawberry_star", "Moono Strawberry Star")

reg_craft ({
    output = needitem .. " 4" ,
    recipe = {
        { "wool:white" , "wool:white" , "wool:red"  } ,
        { "wool:green" , "wool:red"   , "wool:blue" } ,
        { ""           , "wool:white" , ""          } ,
    }
})

-- ===================================================================
-- End of file.
