-- ===================================================================

unified_foods = {}

-- ===================================================================

if minetest.setting_getbool ("disable_hunger") then
    unified_foods.disable_hunger = true
    unified_foods.enable_hunger  = false
else
    unified_foods.disable_hunger = false
    unified_foods.enable_hunger  = true
end

-- ===================================================================

local modname = minetest.get_current_modname()
local modpath = minetest.get_modpath (modname)

unified_foods.modname = modname
unified_foods.modpath = modpath

-- ===================================================================

if not unified_foods.disable_hunger then
    dofile (modpath .. "/hunger.lua")
end

dofile (modpath .. "/entities.lua"         )
dofile (modpath .. "/foodcore.lua"         )
dofile (modpath .. "/basefoods.lua"        )
dofile (modpath .. "/vessels.lua"          )
dofile (modpath .. "/dairy.lua"            )

dofile (modpath .. "/fruits-pineapple.lua" )
dofile (modpath .. "/fruits-other.lua"     )

dofile (modpath .. "/veg-onion.lua"        )
dofile (modpath .. "/veg-potato.lua"       )
dofile (modpath .. "/veg-other.lua"        )

dofile (modpath .. "/chocolate.lua"        )
dofile (modpath .. "/coffee.lua"           )

dofile (modpath .. "/dessert-dseries.lua"  )
dofile (modpath .. "/dessert-moono.lua"    )
dofile (modpath .. "/dessert-other.lua"    )

dofile (modpath .. "/more-items.lua"       )

if not unified_foods.disable_hunger then
    dofile (modpath .. "/adjust-external.lua")
end

-- ===================================================================
-- End of file.
