-- ===================================================================
-- "ufoods" common header.

local S
if minetest.get_modpath ("intllib") then
    S = intllib.Getter()
else
    S = function (s) return s end
end

local item_eat     = unified_foods.item_eat
local keep_vessels = unified_foods.keep_vessels
local mra          = minetest.registered_aliases
local mri          = minetest.registered_items

local reg_alias    = ocutil.safe_register_alias
local reg_craft    = minetest.register_craft
local reg_food     = unified_foods.register_food
local reg_item     = ocutil.safe_register_item
local reg_juice    = unified_foods.register_juice

local needitem

-- ===================================================================

local obj

-- ===================================================================
-- Beetle Juice.

ocutil.add_item_groups ("codermobs:bug" , { food_bug=1 })

needitem = reg_juice ("bug",
    {
        satiate    = 5 ,
        need_count = 6 ,
    })

reg_alias ("beetlejuice"  , needitem)
reg_alias ("beetle_juice" , needitem)

-- ===================================================================
-- Worm Juice.

needitem = reg_juice ("worm",
    {
        satiate    = 5 ,
        need_count = 6 ,
    })

-- ===================================================================
-- Hamburger Juice.

needitem = reg_food ("hamburger",
    {
        description = "Hamburger" ,
        satiate     = 6           ,
    })

reg_craft ({
    output = needitem ,
    recipe = {
        { "group:food_bread" } ,
        { "group:food_meat"  } ,
        { "group:food_bread" } ,
    }
})

reg_alias ("burger"      , needitem)
reg_alias ("food:burger" , needitem)

-- ===================================================================
-- Hamburger Juice.

needitem = reg_juice ("hamburger",
    {
        satiate = 5         ,
        color   = "#441C00" ,
    })

-- ===================================================================

reg_food ("pasta_raw",
    {
        description = "Raw Pasta" ,
        satiate     = 4           ,
    })

reg_craft ({
    type   = "shapeless"      ,
    output = needitem .. " 4" ,

    recipe = {
        "group:food_flour", "group:food_egg", "group:food_egg"
    }
})

-- ===================================================================

needitem = reg_food ("pasta_cooked",
    {
        description  = "Cooked Pasta"   ,
        satiate      = 4                ,
        extra_groups = { food_pasta=1 } ,
    })

reg_craft ({
    type   = "cooking"              ,
    output = needitem               ,
    recipe = "group:food_pasta_raw" ,
})

-- ===================================================================

needitem = reg_food ("cereal01",
    {
        description = "Breakfast Cereal #01" ,
        satiate     = 4                      ,
        drawtype    = "allfaces"             ,
    })

-- ===================================================================

needitem = reg_food ("cereal02",
    {
        description = "Breakfast Cereal #02" ,
        satiate     = 4                      ,
        drawtype    = "allfaces"             ,
    })

-- ===================================================================

needitem = reg_food ("taco",
    {
        description = "Taco"                  ,
        tiles       = "ufoods_taco_horiz.png" ,
        inv         = "ufoods_taco_horiz.png" ,
        satiate     = 4                       ,
    })

-- ===================================================================

needitem = reg_food ("dogtreat01",
    {
        description = "Dog Treats" ,
        drawtype    = "allfaces"   ,
        satiate     = 4            ,
    })

-- ===================================================================

ocutil.add_item_groups ("default:nyancat"         ,
    { food_rainbow=1 })
ocutil.add_item_groups ("default:nyancat_rainbow" ,
    { food_rainbow=1 })

needitem = reg_juice ("rainbow")

-- ===================================================================

obj = unified_foods.color_drink ("#4179D1")

needitem = reg_food ("glass_romulan_ale",
    {
        description = "Glass of Romulan Ale" ,
        image       = obj                    ,
        satiate     = 6                      ,
        replace     = "food:glass"           ,
    })

-- ===================================================================

obj = unified_foods.color_drink ("#BEAF8F")

needitem = reg_food ("glass_ginger_ale",
    {
        description = "Glass of Ginger Ale"  ,
        image       = obj                    ,
        satiate     = 6                      ,
        replace     = "food:glass"           ,
    })

-- ===================================================================

local obj_glass = "default:glass"

needitem = reg_food ("apple_cider",
    {
        description    = "Apple Cider in Bottle" ,
        satiate        = 2                       ,
        external_items = "mtfoods:apple_cider"   ,
    })

reg_craft ({
    output = needitem ,
    recipe = {
        { ""        , "default:steel_ingot"    , ""        } ,
        { obj_glass , "group:food_apple_juice" , obj_glass } ,
        { obj_glass , "group:food_apple_juice" , obj_glass } ,
    }
})

reg_alias ("mtfoods:apple_cider", needitem)

-- ===================================================================
-- End of file.
