-- Poikilos BOM (Byte-Order Mark).

-- ===================================================================
-- Media licenses.

-- This one applies to the model and the associated mesh texture:
--
-- You may  copy, use, modify  or do nearly anything  but  remove this
-- notice.  Of course, you're not allowed to pretend that you've crea-
-- ted or written the Poikilos pieces.
--
-- (c) 2019 and CC-BY-SA 4.0: Poikilos.

-- "*bom_death*" and "*bom_fuse*":
-- (c) 2019 and CC0: Seidolon and Poikilos.

-- "*bom_explode*" and "*damage_hollow_metal*":
-- (c) 2019 and CC0: Deganoth and Poikilos.

-- ===================================================================

local lcname     = "bom"
local ucname     = "Byte-Order Mark"
local msname     = "codermobs_" .. lcname
local obj_name   = "codermobs:" .. lcname

-- ===================================================================

mobs_param = {
    lcname       = lcname       ,
    ucname       = ucname       ,
    obj_name     = obj_name     ,

    aoc          =     -1       ,
    spawn_chance =  50000       ,

    day_mode     = false        ,
    min_light    =      0       ,
    max_light    =      7       ,
    min_height   =      1       ,
    max_height   =    200       ,

    spawn_type   = "monster"    ,

    spawn_nodes  = {
        "default:desert_sand"   ,
        "default:silver_sand"   ,
    } ,

    add_egg   = true                ,
    egg_image = "default_brick.png" ,
}

-- ===================================================================

codermobs.adjust_param()

-- ===================================================================

mobs_param.core_param = {
    type = mobs_param.spawn_type    ,
    makes_footstep_sound = true     ,

    armor            = 100          ,
    attack_animals   = false        ,
    attack_type      = "explode"    ,
    damage           =   3          ,
    explosion_radius =   3          ,
    fall_damage      =   0          ,
    hp_min           =   7          ,
    hp_max           =  33          ,
    stepheight       = 1.2          ,
    jump_height      =   0          ,
    jump             = false        ,
    lava_damage      =   0          ,
    light_damage     =   2          ,
    passive          = false        ,
    pathfinding      = true         ,
    reach            =   2          ,
    run_velocity     =   2          ,
    view_range       =  10          ,
    walk_velocity    =   1          ,
    water_damage     =   0          ,
    floats           =   0          ,

    textures      = {{ msname .. "_mesh.png" }}           ,
    collisionbox  = { -0.65, 0, -0.65, 0.65, 1.75, 0.65 } ,
    visual_scale  = 2                                     ,
    mesh          = "codermobs_bom.b3d"                   ,
    visual        = "mesh"                                ,

    animation     = {
        stand_start  =  1 ,
        stand_end    = 29 ,
        walk_start   = 31 ,
        walk_end     = 50 ,
        run_start    = 31 ,
        run_end      = 50 ,
        speed_normal =  5 ,
        speed_run    = 10 ,
    } ,

    drops = {
        { name="default:apple", chance=2, min=1, max=3 } ,
    } ,

    sounds = {
        damage  = "codermobs_damage_hollow_metal" ,
        death   = "codermobs_bom_death"           ,
        explode = "codermobs_bom_explode"         ,
        fuse    = "codermobs_bom_fuse"            ,
    } ,
}

-- ===================================================================

codermobs.setup_mob()
codermobs.log_done()

-- ===================================================================
-- End of file.
