-- Horse.
-- Descended from Farlands version.
-- Final MT version by OldCoder.
-- Edits by Greg Yurkon.

-- ===================================================================

local lcname     = "farhorse"
local ucname     = "Farlands Horse"
local msname     = "codermobs_" .. lcname
local obj_name   = "codermobs:" .. lcname

-- ===================================================================

mobs_param = {
    lcname       = lcname       ,
    ucname       = ucname       ,
    obj_name     = obj_name     ,

    aoc          =     -1       ,
    spawn_chance =  80000       ,

    day_mode     = true         ,
    min_light    =      7       ,
    max_light    =     20       ,
    min_height   = -31000       ,
    max_height   =  11000       ,

    spawn_type   = "animal"     ,

    spawn_nodes  = {
        "default:dirt_with_dry_grass"   ,
        "default:dirt_with_grass"       ,
        "noisegrid:grass"               ,
    } ,

    add_egg   = true                    ,
    egg_image = "default_dirt.png"      ,
}

-- ===================================================================

codermobs.adjust_param()

-- ===================================================================

mobs_param.core_param = {
    type = mobs_param.spawn_type ,
    passive = false,
    reach         =   1         ,
    damage        =   2         ,
    attack_type   = "dogfight"  ,
    hp_min = 50,
    hp_max = 60,
    armor = 120,

    collisionbox = {-0.5, 0, -0.5, 0.5, 1.5, 0.5},
    visual = "mesh",
    mesh = msname .. ".b3d" ,
    textures = {
        { msname .. ".png" } ,
    },

    blood_texture = "codermobs_blood.png",
    makes_footstep_sound = true,
    walk_velocity = 1.5,
    run_velocity = 3,
    stepheight    = 2.2         ,
    jump_height   =   0         ,
    jump          = false       ,
    water_damage = 1,
    floats = 0,
    runaway = true,
    lava_damage = 2,
    light_damage = 0,
    fall_damage = 1,
    fear_height = 2,
    replace_rate = 10,

    replace_what = {
        "default:grass_3" ,
        "default:grass_4" ,
        "default:grass_5" ,
        "ethereal:bamboo" ,
    } ,

    replace_with = "air",
    follow = {"farming:wheat"},
    view_range = 14,

    drops = {
        { name="mobs:meat_raw", chance=2, min=3, max=4 } ,
    } ,

    specific_attack = codermobs.make_mob_list ({
        "snake_garter", "snake_ice",
    }) ,

    animation = {
        speed_normal = 16,
        speed_run = 22,
        walk_start = 25,
        walk_end = 45,
        stand_start = 80,
        stand_end = 120,
        run_start = 50,
        run_end = 70,

    },

    on_rightclick = function (self, clicker)
        if mobs:feed_tame(self, clicker, 8, true, true) then
            return
        end

        if self.driver and clicker == self.driver then
            mobs.detach (clicker, { x=1, y=0, z=1 })
        elseif not self.driver and clicker:get_wielded_item():get_name() == "mobs:saddle" then
            mobs.attach (self, clicker)
        end

        mobs:capture_mob (self, clicker, 0, 5, 50, false, nil)
    end,

    do_custom = function (self, dtime)
    if self.driver then
        self.state = "stand"
        mobs.drive (self, nil, nil, true, dtime)
        return false
        end
    return true
    end,
}

-- ===================================================================

codermobs.setup_mob()
codermobs.log_done()

-- ===================================================================
-- End of file.
