-- Owl. Descended from "dmobs" version.

-- ===================================================================

local lcname     = "owl"
local ucname     = "Owl"
local msname     = "codermobs_" .. lcname
local obj_name   = "codermobs:" .. lcname

-- ===================================================================

mobs_param = {
    lcname       = lcname       ,
    ucname       = ucname       ,
    obj_name     = obj_name     ,

    aoc          =     -1       ,
    spawn_chance = 100000       ,

    day_mode     = true         ,
    min_light    =     10       ,
    max_light    =     30       ,
    min_height   = -31000       ,
    max_height   =  31000       ,

    spawn_type   = "animal"     ,

    spawn_nodes  = {
        "default:dirt_with_grass"       ,
        "fargen:dirt_with_junglegrass"  ,
        "fargen:palm_leaves"            ,
    } ,

    add_egg   = true                    ,
    egg_image = "default_tree.png"      ,
}

-- ===================================================================

codermobs.adjust_param()

-- ===================================================================

mobs_param.core_param = {
    type = mobs_param.spawn_type ,
    passive = true,
    hp_min = 12,
    hp_max = 22,
    armor = 130,
    collisionbox = {-0.3, -0.5, -0.3, 0.2, 0.2, 0.2},
    visual = "mesh",
    mesh = msname .. ".b3d" ,
    textures = {
        { msname .. ".png"} ,
    },
    blood_texture = "mobs_blood.png",
    visual_size = {x=2, y=2},
    makes_footstep_sound = false,
    walk_velocity = 0,
    run_velocity = 0,
    jump = false,
    water_damage = 2,
    lava_damage = 2,
    light_damage = 0,
    view_range = 1,
    do_custom = function(self)
    local daytime = minetest.get_timeofday()*24000
    if daytime <=6000 then
    self.object:set_properties({
                        textures = {"codermobs_owl_awake.png"},
                        mesh = msname .. ".b3d" ,
                    })
    elseif daytime >=6000 then
    self.object:set_properties({
                        textures = { msname .. ".png"},
                        mesh = msname .. ".b3d" ,
                    })
    end
    end,
    animation = {
        speed_normal = 1,
        walk_start = 1,
        walk_end = 50,

    },
}

-- ===================================================================

codermobs.setup_mob()
codermobs.log_done()

-- ===================================================================
-- End of file.
