-- ===================================================================

local YMIN = upper_realms.mtspace.y_min
local YMAX = upper_realms.mtspace.y_max
local XMIN = -31008
local XMAX =  31008
local ZMIN = -31008
local ZMAX =  31008

-- ===================================================================

local c_air    = minetest.get_content_id ("air")
local c_vacuum = default.c_vacuum

-- ===================================================================

minetest.register_on_generated (function (minp, maxp, seed)

    if minp.x < XMIN or maxp.x > XMAX
    or minp.y < YMIN or maxp.y > YMAX
    or minp.z < ZMIN or maxp.z > ZMAX then
        return
    end

    if upper_realms.is_loud_walking (minp, maxp) then
        return
    end

    local x1 = maxp.x
    local y1 = maxp.y
    local z1 = maxp.z

    local x0 = minp.x
    local y0 = minp.y
    local z0 = minp.z

-- ===================================================================

    local vm, emin, emax = minetest.get_mapgen_object ("voxelmanip")
    local area = VoxelArea:new { MinEdge=emin, MaxEdge=emax }
    local data = vm:get_data()

-- ===================================================================

    if c_vacuum ~= c_air then
        for z = z0, z1 do
            for y = y0, y1 do
                for x = x0, x1 do
                    local vix = area:index (x, y, z)
                    if  data [vix] == c_air then
                        data [vix] =  c_vacuum
                    end
                end
            end
        end
    end

-- ===================================================================

    vm:set_data (data)
    vm:set_lighting ({ day=15, night=15 })
    vm:calc_lighting (nil, nil, false)
    vm:write_to_map()
    upper_realms.set_space_light (vm, area, minp, maxp)
end)

-- ===================================================================

minetest.log ("action", "[mtspace] Mod loaded")

-- ===================================================================
-- End of file.
